<template>
  <div class="container">
    <h1>Календарь игр одной команды</h1>
    <div class="date-filter">
      <p>Фильтр по дате</p>
      c <input type="date" name="" id="" v-model="dateFrom" /> по
      <input type="date" name="" id="" v-model="dateBy" />
      <p>Выбирите сезон</p>
      <Seasons @seasonChanged="onSeasonChanged" :selectedSeason="season" />
      <br />
      <router-link
        :to="{ name: 'Fixtures', params: { id: leagueId, season: season } }"
      >
        <button>Вернуться в календарь лиги</button>
      </router-link>
    </div>
    <hr />
    <div class="container-leagues" v-for="fix in searchHandler" :key="fix.id">
      <div class="title-box">
        <p>Local Team</p>
        <p id="elapsed">{{ fix.date.toDateString() }}</p>
        <p>Visitor Team</p>
      </div>
      <div class="title-box">
        <div class="team">
          <img id="homeLogo" :src="fix.teamHome.logo" alt="" />
          <p id="homeName">{{ fix.teamHome.name }}</p>
        </div>
        <p id="goals">{{ fix.goalsHome }} - {{ fix.goalsAway }}</p>
        <div class="team">
          <img id="awayLogo" :src="fix.teamAway.logo" alt="" />
          <p id="awayName">{{ fix.teamAway.name }}</p>
        </div>
      </div>
      <hr />
      <div id="matchTable" class="matches-table"></div>
      <br />
    </div>
  </div>
</template>

<script>
import Seasons from "./Seasons.vue";
export default {
  components: { Seasons },

  data() {
    return {
      fixturesTeam: [],
      teamId: null,
      season: null,
      leagueId: null,
      dateFrom: "",
      dateBy: "",
    };
  },
  mounted() {
    this.teamId = this.$route.params.id;
    this.season = this.$route.params.season;
    this.leagueId = this.$route.params.leagueId;
    this.getTeams();
  },

  methods: {
    onSeasonChanged(event) {
      let params = this.$route.params;
      params["season"] = event;
      this.$router
        .push({ name: this.$route.name, params: params })
        .catch(() => {});
      this.season = event;
      this.getTeams();
    },
    getTeams() {
      const url = `https://v3.football.api-sports.io/fixtures?team=${this.teamId}&season=${this.season}&league=${this.leagueId}`;
      fetch(url, {
        method: "GET",
        headers: {
          "x-rapidapi-host": "v3.football.api-sports.io",
          "x-rapidapi-key": process.env.VUE_APP_API_KEY,
        },
      })
        .then((response) =>
          response.json().then((data) => {
            this.fixturesTeam = data.response.map((fix) => {
              return {
                id: fix.fixture.id,
                date: new Date(fix.fixture.date),
                leagueId: fix.league.id,
                goalsHome: fix.goals.home,
                goalsAway: fix.goals.away,
                teamHome: {
                  id: fix.teams.home.id,
                  name: fix.teams.home.name,
                  logo: fix.teams.home.logo,
                },
                teamAway: {
                  id: fix.teams.away.id,
                  name: fix.teams.away.name,
                  logo: fix.teams.away.logo,
                },
              };
            });
          })
        )
        .catch((err) => {
          console.log(err);
        });
    },
  },
  computed: {
    searchHandler() {
      const startDate = this.dateFrom
        ? new Date(this.dateFrom)
        : new Date("01.01.0001");
      const endDate = this.dateBy
        ? new Date(this.dateBy)
        : new Date("01.01.9999");

      return this.fixturesTeam.filter(
        (elm) => elm.date >= startDate && elm.date <= endDate
      );
    },
  },
};
</script>

<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Roboto");

* {
  margin: 0;
  padding: 0;
  outline: 0;
  font-family: "Roboto", sans-serif;
  text-align: center;
}

body {
  height: 100vh;
}

.header {
  width: 52%;
  height: 25%;
  background-color: #fafafa;
  margin-left: 296px;
  margin-top: 0px;
  padding: 2px;
  border: 1px solid black;
}
.date-filter {
  margin-top: 15px;
  margin-bottom: 40px;
  text-transform: initial;
}
.date-filter button {
  margin-top: 10px;
  cursor: pointer;
}
.date-filter p {
  margin-top: 10px;
}
.container {
  position: relative;
  padding: 16px;
  top: 150%;
  left: 25%;
  width: 50%;
  background-color: #fafafa;
  text-align: center;
  border-radius: 4px;
  text-transform: uppercase;
  text-align: center;
}

.title-box {
  margin: 25px 0;
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
  justify-content: space-around;
  align-items: center;
  width: 100%;
  font-size: 1.5em;
}
.title-box #goals {
  font-size: 1.8em;
}
.team {
  width: 100px;
}
.team img {
  height: 54px;
  width: 54px;
}
.matches-table {
  margin-top: 50px;
  display: flex;
  flex-direction: column;
}
.match-tile {
  position: relative;
  left: 50%;
  transform: translateX(-50%);
  margin: 10px 0;
  display: flex;
  flex-direction: row;
  justify-content: space-around;
  align-items: center;
}
.match-tile img {
  width: 52px;
  height: 52px;
}
.match-tile p {
  font-size: 1.2rem;
}

.match-tile #goals {
  font-size: 1.8rem;
}
.match-tile .team {
  width: 100px;
}
</style>
